SystemOrganization addCategory: 'tODE-GemStone-Core'!

TOSystem subclass: #TOGemStoneSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-GemStone-Core'!

!TOGemStoneSystem classSide methodsFor: 'class initialization' stamp: 'dkh 05/21/2011 03:27'!
initialize
	"self initialize"
	
	self select! !

!TOGemStoneSystem methodsFor: 'expression evaluation' stamp: 'DataCurator 07/14/2011 05:53'!
evaluate: aString in: aContext to: receiver notifying: aRequestor ifFail: failBlock

	^aString evaluateInContext: receiver symbolList: self symbolList! !

!TOGemStoneSystem methodsFor: 'symbol list' stamp: 'dkh 05/21/2011 03:30'!
symbolList

	^ GsSession currentSession symbolList! !

!TOSystem methodsFor: '*tode-gemstone-core' stamp: 'dkh 08/04/2011 17:11'!
allMethodsWithSourceString: aString matchCase: caseSensitive
	^ SystemNavigation default
		allMethodsSelect: [ :methodRef | (methodRef sourceString findString: aString startingAt: 1 caseSensitive: caseSensitive) > 0 ]! !

!TOSystem methodsFor: '*tode-gemstone-core' stamp: 'dkh 07/12/2011 14:12'!
classHierarchyFor: aClass

	^(({Object. ProtoObject. Class. Behavior. } includes: aClass)
		ifTrue: [{aClass}, aClass allSuperclasses]
		ifFalse: [aClass withAllSubclasses, aClass allSuperclasses]) asArray! !

!TOSystem methodsFor: '*tode-gemstone-core' stamp: 'dkh 07/12/2011 14:11'!
methodReferenceClass

	^MethodReference! !

!TOObject methodsFor: '*tode-gemstone-core' stamp: 'dkh 07/24/2011 09:53'!
deploy: aBlock
	GsDeployer deploy: aBlock! !

!TOObject methodsFor: '*tode-gemstone-core' stamp: 'dkh 08/09/2011 10:52'!
doit: aString pushResult: pushResult selecting: aTabSelector main: main
	| processResult semaphore process |
	semaphore := Semaphore new.
	process := [ 
	[ 
	processResult := main currentSystem
		evaluate: aString
		in: nil
		to: self object
		notifying: nil
		ifFail: [ self error: 'evaluation failed' ].
	pushResult
		ifTrue: [ self pushit: processResult selecting: aTabSelector main: main ] ]
		on: Error , Halt
		do: [ :ex | 
			main currentSession
				push:
					((TODoItException new)
						exception: ex;
						process: process;
						yourself)
				selecting: #debug.
			semaphore signal.
			Processor activeProcess suspend.
			ex isResumable
				ifTrue: [ ex resume ].
			processResult := 'Exception is not resumable: ' , ex description ].
	semaphore signal ]
		fork.
	semaphore wait.
	^ processResult! !

!TOHome classSide methodsFor: '*tode-gemstone-core' stamp: 'dkh 05/21/2011 06:49'!
workspaceBookmarks
           <tODEBookmark>
   
           | bookmarks |
           bookmarks := OrderedCollection new.
            bookmarks add: ((TOExternalBookmark new)
                   object: 'http://localhost:8080/tools/objectLog';
                   label: 'Object Log';
                   yourself).
           ^bookmarks
! !
TOGemStoneSystem initialize!
